Whamcloud - gitweb
LU-1193 tests: test script fixes for incompatibility
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
index c02fd18..7ef48f4 100755 (executable)
@@ -2,23 +2,17 @@
 
 set -e
 
-#         bug  5494 7288 5493
-ALWAYS_EXCEPT="24   27   52 $RECOVERY_SMALL_EXCEPT"
+#         bug  5494 5493
+ALWAYS_EXCEPT="24   52 $RECOVERY_SMALL_EXCEPT"
 
 PTLDEBUG=${PTLDEBUG:--1}
 LUSTRE=${LUSTRE:-`dirname $0`/..}
 . $LUSTRE/tests/test-framework.sh
 init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
+init_logging
 
-if [ "$FAILURE_MODE" = "HARD" ] && mixed_ost_devs; then
-    CONFIG_EXCEPTIONS="52"
-    echo -n "Several ost services on one ost node are used with FAILURE_MODE=$FAILURE_MODE. "
-    echo "Except the tests: $CONFIG_EXCEPTIONS"
-    ALWAYS_EXCEPT="$ALWAYS_EXCEPT $CONFIG_EXCEPTIONS"
-fi
-
-remote_mds_nodsh && skip "remote MDS with nodsh" && exit 0
+require_dsh_mds || exit 0
 
 # also long tests: 19, 21a, 21e, 21f, 23, 27
 #                                   1  2.5  2.5    4    4          (min)"
@@ -31,7 +25,7 @@ build_test_filter
 SETUP=${SETUP:-""}
 CLEANUP=${CLEANUP:-""}
 
-cleanup_and_setup_lustre
+check_and_setup_lustre
 
 assert_DIR
 rm -rf $DIR/[df][0-9]*
@@ -218,7 +212,7 @@ test_17() {
     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
     # With adaptive timeouts, bulk_get won't expire until adaptive_timeout_max
-    if at_is_valid && at_is_enabled; then
+    if at_is_enabled; then
         at_max_saved=$(at_max_get ost1)
         at_max_set $TIMEOUT ost1
     fi
@@ -227,7 +221,7 @@ test_17() {
     # OST bulk will time out here, client retries
     do_facet ost1 lctl set_param fail_loc=0x80000503
     # need to ensure we send an RPC
-    do_facet client cp /etc/termcap $DIR/$tfile
+    do_facet client cp $SAMPLE_FILE $DIR/$tfile
     sync
 
     # with AT, client will wait adaptive_max*factor+net_latency before
@@ -237,15 +231,15 @@ test_17() {
     do_facet ost1 lctl set_param fail_loc=0
     do_facet client "df $DIR"
     # expect cmp to succeed, client resent bulk
-    do_facet client "cmp /etc/termcap $DIR/$tfile" || return 3
+    do_facet client "cmp $SAMPLE_FILE $DIR/$tfile" || return 3
     do_facet client "rm $DIR/$tfile" || return 4
-    [ $at_max_saved -ne 0 ] && $(at_max_set $at_max_saved ost1)
+    [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
     return 0
 }
 run_test 17 "timeout bulk get, don't evict client (2732)"
 
 test_18a() {
-    [ -z ${ost2_svc} ] && skip "needs 2 osts" && return 0
+    [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
 
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
@@ -254,7 +248,12 @@ test_18a() {
     pgcache_empty || return 1
 
     # 1 stripe on ost2
-    lfs setstripe $f -s $((128 * 1024)) -i 1 -c 1
+    $LFS setstripe -i 1 -c 1 $f
+    stripe_index=$($LFS getstripe -i $f)
+    if [ $stripe_index -ne 1 ]; then
+        $LFS getstripe $f
+        error "$f: stripe_index $stripe_index != 1" && return
+    fi
 
     do_facet client cp $SAMPLE_FILE $f
     sync
@@ -275,14 +274,16 @@ test_18b() {
 
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
-    f2=$DIR/$tdir/${tfile}-2
 
     cancel_lru_locks osc
     pgcache_empty || return 1
 
-    # shouldn't have to set stripe size of count==1
-    lfs setstripe $f -s $((128 * 1024)) -i 0 -c 1
-    lfs setstripe $f2 -s $((128 * 1024)) -i 0 -c 1
+    $LFS setstripe -i 0 -c 1 $f
+    stripe_index=$($LFS getstripe -i $f)
+    if [ $stripe_index -ne 0 ]; then
+        $LFS getstripe $f
+        error "$f: stripe_index $stripe_index != 0" && return
+    fi
 
     do_facet client cp $SAMPLE_FILE $f
     sync
@@ -293,7 +294,7 @@ test_18b() {
     # cache after the client reconnects?     
     rc=0
     pgcache_empty || rc=2
-    rm -f $f $f2
+    rm -f $f
     return $rc
 }
 run_test 18b "eviction and reconnect clears page cache (2766)"
@@ -303,14 +304,16 @@ test_18c() {
 
     do_facet client mkdir -p $DIR/$tdir
     f=$DIR/$tdir/$tfile
-    f2=$DIR/$tdir/${tfile}-2
 
     cancel_lru_locks osc
     pgcache_empty || return 1
 
-    # shouldn't have to set stripe size of count==1
-    lfs setstripe $f -s $((128 * 1024)) -i 0 -c 1
-    lfs setstripe $f2 -s $((128 * 1024)) -i 0 -c 1
+    $LFS setstripe -i 0 -c 1 $f
+    stripe_index=$($LFS getstripe -i $f)
+    if [ $stripe_index -ne 0 ]; then
+        $LFS getstripe $f
+        error "$f: stripe_index $stripe_index != 0" && return
+    fi
 
     do_facet client cp $SAMPLE_FILE $f
     sync
@@ -320,13 +323,14 @@ test_18c() {
     # lost reply to connect request
     do_facet ost1 lctl set_param fail_loc=0x80000225
     # force reconnect
+    sleep 1
     df $MOUNT > /dev/null 2>&1
     sleep 2
     # my understanding is that there should be nothing in the page
     # cache after the client reconnects?     
     rc=0
     pgcache_empty || rc=2
-    rm -f $f $f2
+    rm -f $f
     return $rc
 }
 run_test 18c "Dropped connect reply after eviction handing (14755)"
@@ -361,7 +365,7 @@ test_20a() {        # bug 2983 - ldlm_handle_enqueue cleanup
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
        mkdir -p $DIR/$tdir
-       lfs setstripe $DIR/$tdir/${tfile} -i 0 -c 1
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
        multiop_bg_pause $DIR/$tdir/${tfile} O_wc || return 1
        MULTI_PID=$!
        cancel_lru_locks osc
@@ -378,7 +382,7 @@ test_20b() {        # bug 2986 - ldlm_handle_enqueue error during open
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
        mkdir -p $DIR/$tdir
-       lfs setstripe $DIR/$tdir/${tfile} -i 0 -c 1
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
        cancel_lru_locks osc
 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
        do_facet ost1 lctl set_param fail_loc=0x80000308
@@ -619,7 +623,7 @@ test_24() { # bug 11710 details correct fsync() behavior
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
        mkdir -p $DIR/$tdir
-       lfs setstripe $DIR/$tdir -s 0 -i 0 -c 1
+       $LFS setstripe -i 0 -c 1 $DIR/$tdir
        cancel_lru_locks osc
        multiop_bg_pause $DIR/$tdir/$tfile Owy_wyc || return 1
        MULTI_PID=$!
@@ -633,54 +637,81 @@ test_24() { # bug 11710 details correct fsync() behavior
 }
 run_test 24 "fsync error (should return error)"
 
+wait_client_evicted () {
+       local facet=$1
+       local exports=$2
+       local varsvc=${facet}_svc
+
+       wait_update $(facet_active_host $facet) \
+                "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
+                $((exports - 1)) $3
+}
+
 test_26a() {      # was test_26 bug 5921 - evict dead exports by pinger
 # this test can only run from a client on a separate node.
        remote_ost || { skip "local OST" && return 0; }
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
        remote_mds || { skip "local MDS" && return 0; }
-       OST_FILE=obdfilter.${ost1_svc}.num_exports
-        OST_EXP="`do_facet ost1 lctl get_param -n $OST_FILE`"
-       OST_NEXP1=`echo $OST_EXP | cut -d' ' -f2`
-       echo starting with $OST_NEXP1 OST exports
+
+        if [ $(facet_host mgs) = $(facet_host ost1) ]; then
+                skip "msg and ost1 are at the same node"
+                return 0
+        fi
+
+       check_timeout || return 1
+
+       local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
+
+       echo starting with $OST_NEXP OST exports
 # OBD_FAIL_PTLRPC_DROP_RPC 0x505
        do_facet client lctl set_param fail_loc=0x505
         # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
         # But if there's a race to start the evictor from various obds,
         # the loser might have to wait for the next ping.
-       echo Waiting for $(($TIMEOUT * 8)) secs
-       sleep $(($TIMEOUT * 8))
-        OST_EXP="`do_facet ost1 lctl get_param -n $OST_FILE`"
-       OST_NEXP2=`echo $OST_EXP | cut -d' ' -f2`
-       echo ending with $OST_NEXP2 OST exports
+
+       local rc=0
+       wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
+       rc=$?
        do_facet client lctl set_param fail_loc=0x0
-        [ $OST_NEXP1 -le $OST_NEXP2 ] && error "client not evicted"
-       return 0
+        [ $rc -eq 0 ] || error "client not evicted from OST"
 }
 run_test 26a "evict dead exports"
 
 test_26b() {      # bug 10140 - evict dead exports by pinger
        remote_ost_nodsh && skip "remote OST with nodsh" && return 0
 
-       client_df
-        zconf_mount `hostname` $MOUNT2 || error "Failed to mount $MOUNT2"
-        sleep 1 # wait connections being established
-       MDS_FILE=mdt.${mds1_svc}.num_exports
-        MDS_NEXP1="`do_facet $SINGLEMDS lctl get_param -n $MDS_FILE | cut -d' ' -f2`"
-        OST_FILE=obdfilter.${ost1_svc}.num_exports
-        OST_NEXP1="`do_facet ost1 lctl get_param -n $OST_FILE | cut -d' ' -f2`"
-        echo starting with $OST_NEXP1 OST and $MDS_NEXP1 MDS exports
-        zconf_umount `hostname` $MOUNT2 -f
-        # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.  
-        # But if there's a race to start the evictor from various obds, 
-        # the loser might have to wait for the next ping.
-        echo Waiting for $(($TIMEOUT * 3)) secs
-        sleep $(($TIMEOUT * 3))
-        OST_NEXP2="`do_facet ost1 lctl get_param -n $OST_FILE | cut -d' ' -f2`"
-        MDS_NEXP2="`do_facet $SINGLEMDS lctl get_param -n $MDS_FILE | cut -d' ' -f2`"
-        echo ending with $OST_NEXP2 OST and $MDS_NEXP2 MDS exports
-        [ $OST_NEXP1 -le $OST_NEXP2 ] && error "client not evicted from OST"
-        [ $MDS_NEXP1 -le $MDS_NEXP2 ] && error "client not evicted from MDS"
-       return 0
+        if [ $(facet_host mgs) = $(facet_host ost1) ]; then
+                skip "msg and ost1 are at the same node"
+                return 0
+        fi
+
+       check_timeout || return 1
+       clients_up
+       zconf_mount `hostname` $MOUNT2 ||
+                { error "Failed to mount $MOUNT2"; return 2; }
+       sleep 1 # wait connections being established
+
+       local MDS_NEXP=$(do_facet $SINGLEMDS lctl get_param -n mdt.${mds1_svc}.num_exports | cut -d' ' -f2)
+       local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
+
+       echo starting with $OST_NEXP OST and $MDS_NEXP MDS exports
+
+       zconf_umount `hostname` $MOUNT2 -f
+
+       # PING_INTERVAL max(obd_timeout / 4, 1U)
+       # PING_EVICT_TIMEOUT (PING_INTERVAL * 6)
+
+       # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.  
+       # But if there's a race to start the evictor from various obds, 
+       # the loser might have to wait for the next ping.
+       # = 9 * PING_INTERVAL + PING_INTERVAL
+       # = 10 PING_INTERVAL = 10 obd_timeout / 4 = 2.5 obd_timeout
+       # let's wait $((TIMEOUT * 3)) # bug 19887
+       local rc=0
+       wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 3)) || \
+               error "Client was not evicted by ost" rc=1
+       wait_client_evicted $SINGLEMDS $MDS_NEXP $((TIMEOUT * 3)) || \
+               error "Client was not evicted by mds"
 }
 run_test 26b "evict dead exports"
 
@@ -695,12 +726,8 @@ test_27() {
 #define OBD_FAIL_OSC_SHUTDOWN            0x407
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000407
        # need to wait for reconnect
-       echo -n waiting for fail_loc
-       while [ $(do_facet $SINGLEMDS lctl get_param -n fail_loc) -eq -2147482617 ]; do
-           sleep 1
-           echo -n .
-       done
-       do_facet $SINGLEMDS lctl get_param -n fail_loc
+       echo waiting for fail_loc
+       wait_update_facet $SINGLEMDS "lctl get_param -n fail_loc" "-2147482617"
        facet_failover $SINGLEMDS
        #no crashes allowed!
         kill -USR1 $CLIENT_PID
@@ -716,12 +743,32 @@ test_28() {      # bug 6086 - error adding new clients
        #define OBD_FAIL_MDS_CLIENT_ADD 0x12f
        do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012f"
        # fail once (evicted), reconnect fail (fail_loc), ok
-       df || (sleep 10; df) || (sleep 10; df) || error "reconnect failed"
+       client_up || (sleep 10; client_up) || (sleep 10; client_up) || error "reconnect failed"
        rm -f $DIR/$tfile
        fail $SINGLEMDS         # verify MDS last_rcvd can be loaded
 }
 run_test 28 "handle error adding new clients (bug 6086)"
 
+test_29a() { # bug 22273 - error adding new clients
+       #define OBD_FAIL_TGT_CLIENT_ADD 0x711
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000711"
+       # fail abort so client will be new again
+       fail_abort $SINGLEMDS
+       client_up || error "reconnect failed"
+       return 0
+}
+run_test 29a "error adding new clients doesn't cause LBUG (bug 22273)"
+
+test_29b() { # bug 22273 - error adding new clients
+       #define OBD_FAIL_TGT_CLIENT_ADD 0x711
+       do_facet ost1 "lctl set_param fail_loc=0x80000711"
+       # fail abort so client will be new again
+       fail_abort ost1
+       client_up || error "reconnect failed"
+       return 0
+}
+run_test 29b "error adding new clients doesn't cause LBUG (bug 22273)"
+
 test_50() {
        mkdir -p $DIR/$tdir
        # put a load of file creates/writes/deletes
@@ -748,6 +795,9 @@ test_50() {
 run_test 50 "failover MDS under load"
 
 test_51() {
+       #define OBD_FAIL_MDS_SYNC_CAPA_SL                    0x1310
+       do_facet ost1 lctl set_param fail_loc=0x00001310
+
        mkdir -p $DIR/$tdir
        # put a load of file creates/writes/deletes
        writemany -q $DIR/$tdir/$tfile 0 5 &
@@ -841,7 +891,7 @@ test_55() {
        mkdir -p $DIR/$tdir
 
        # first dd should be finished quickly
-       lfs setstripe DIR/$tdir/$tfile-1 -c 1 -i 0
+       $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
        dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4  &
        DDPID=$!
        count=0
@@ -856,7 +906,7 @@ test_55() {
        done    
        echo "(dd_pid=$DDPID, time=$count)successful"
 
-       lfs setstripe DIR/$tdir/$tfile-2 -c 1 -i 0
+       $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-2
        #define OBD_FAIL_OST_DROP_REQ            0x21d
        do_facet ost1 lctl set_param fail_loc=0x0000021d
        # second dd will be never finished
@@ -960,6 +1010,395 @@ test_59() { # bug 10589
 }
 run_test 59 "Read cancel race on client eviction"
 
-equals_msg `basename $0`: test complete, cleaning up
+err17935 () {
+    # we assume that all md changes are in the MDT0 changelog
+    if [ $MDSCOUNT -gt 1 ]; then
+       error_ignore 17935 $*
+    else
+       error $*
+    fi
+}
+
+test_60() {
+        MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid | \
+           awk '{gsub(/_UUID/,""); print $1}' | head -1)
+
+       NUM_FILES=15000
+       mkdir -p $DIR/$tdir
+
+       # Register (and start) changelog
+       USER=$(do_facet $SINGLEMDS lctl --device $MDT0 changelog_register -n)
+       echo "Registered as $MDT0 changelog user $USER"
+
+       # Generate a large number of changelog entries
+       createmany -o $DIR/$tdir/$tfile $NUM_FILES
+       sync
+       sleep 5
+
+       # Unlink files in the background
+       unlinkmany $DIR/$tdir/$tfile $NUM_FILES &
+       CLIENT_PID=$!
+       sleep 1
+
+       # Failover the MDS while unlinks are happening
+       facet_failover $SINGLEMDS
+
+       # Wait for unlinkmany to finish
+       wait $CLIENT_PID
+
+       # Check if all the create/unlink events were recorded
+       # in the changelog
+       $LFS changelog $MDT0 >> $DIR/$tdir/changelog
+       local cl_count=$(grep UNLNK $DIR/$tdir/changelog | wc -l)
+       echo "$cl_count unlinks in $MDT0 changelog"
+
+       do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $USER
+       USERS=$(( $(do_facet $SINGLEMDS lctl get_param -n \
+           mdd.$MDT0.changelog_users | wc -l) - 2 ))
+       if [ $USERS -eq 0 ]; then
+           [ $cl_count -eq $NUM_FILES ] || \
+               err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
+           # Also make sure we can clear large changelogs
+           cl_count=$($LFS changelog $FSNAME | wc -l)
+           [ $cl_count -le 2 ] || \
+               error "Changelog not empty: $cl_count entries"
+       else
+           # If there are other users, there may be other unlinks in the log
+           [ $cl_count -ge $NUM_FILES ] || \
+               err17935 "Recorded ${cl_count} unlinks out of $NUM_FILES"
+           echo "$USERS other changelog users; can't verify clear"
+       fi
+}
+run_test 60 "Add Changelog entries during MDS failover"
+
+test_61()
+{
+       local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $FSNAME-OST0000)
+       mdtosc=${mdtosc/-MDT*/-MDT\*}
+       local cflags="osc.$mdtosc.connect_flags"
+       do_facet $SINGLEMDS "lctl get_param -n $cflags" |grep -q skip_orphan
+       [ $? -ne 0 ] && skip "don't have skip orphan feature" && return
+
+       mkdir -p $DIR/$tdir || error "mkdir dir $DIR/$tdir failed"
+       # Set the default stripe of $DIR/$tdir to put the files to ost1
+       $LFS setstripe -c 1 -i 0 $DIR/$tdir
+
+       replay_barrier $SINGLEMDS
+       createmany -o $DIR/$tdir/$tfile-%d 10 
+       local oid=`do_facet ost1 "lctl get_param -n obdfilter.${ost1_svc}.last_id"`
+
+       fail_abort $SINGLEMDS
+       
+       touch $DIR/$tdir/$tfile
+       local id=`$LFS getstripe $DIR/$tdir/$tfile | awk '$1 == 0 { print $2 }'`
+       [ $id -le $oid ] && error "the orphan objid was reused, failed"
+
+       # Cleanup
+       rm -rf $DIR/$tdir
+}
+run_test 61 "Verify to not reuse orphan objects - bug 17025"
+
+check_cli_ir_state()
+{
+        local NODE=${1:-$HOSTNAME}
+        local st
+        st=$(do_node $NODE "lctl get_param mgc.*.ir_state |
+                            awk '/imperative_recovery:/ { print \\\$2}'")
+        [ $st != ON -o $st != OFF ] ||
+                error "Error state $st, must be ON or OFF"
+        echo -n $st
+}
+
+check_target_ir_state()
+{
+        local target=${1}
+        local name=${target}_svc
+        local recovery_proc=obdfilter.${!name}.recovery_status
+        local st
+
+        st=$(do_facet $target "lctl get_param -n $recovery_proc |
+                               awk '/IR:/{ print \\\$2}'")
+        [ $st != ON -o $st != OFF ] ||
+                error "Error state $st, must be ON or OFF"
+        echo -n $st
+}
+
+set_ir_status()
+{
+        do_facet mgs lctl set_param -n mgs.MGS.live.$FSNAME="state=$1"
+}
+
+get_ir_status()
+{
+        local state=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
+                                    awk '/state:/{ print \\\$2 }'")
+        echo -n ${state/,/}
+}
+
+nidtbl_version_mgs()
+{
+        local ver=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
+                                  awk '/nidtbl_version:/{ print \\\$2 }'")
+        echo -n $ver
+}
+
+# nidtbl_version_client <mds1|client> [node]
+nidtbl_version_client()
+{
+        local cli=$1
+        local node=${2:-$HOSTNAME}
+
+        if [ X$cli = Xclient ]; then
+                cli=$FSNAME-client
+        else
+                local obdtype=${cli/%[0-9]*/}
+                [ $obdtype != mds ] && error "wrong parameters $cli"
+
+                node=$(facet_active_host $cli)
+                local t=${cli}_svc
+                cli=${!t}
+        fi
+
+        local vers=$(do_node $node "lctl get_param -n mgc.*.ir_state" |
+                     awk "/$cli/{print \$6}" |sort -u)
+
+        # in case there are multiple mounts on the client node
+        local arr=($vers)
+        [ ${#arr[@]} -ne 1 ] && error "versions on client node mismatch"
+        echo -n $vers
+}
+
+nidtbl_versions_match()
+{
+        [ $(nidtbl_version_mgs) -eq $(nidtbl_version_client ${1:-client}) ]
+}
+
+target_instance_match()
+{
+        local srv=$1
+        local obdtype
+        local cliname
+
+        obdtype=${srv/%[0-9]*/}
+        case $obdtype in
+        mds)
+                obdname="mdt"
+                cliname="mdc"
+                ;;
+        ost)
+                obdname="obdfilter"
+                cliname="osc"
+                ;;
+        *)
+                error "invalid target type" $srv
+                return 1
+                ;;
+        esac
+
+        local target=${srv}_svc
+        local si=$(do_facet $srv lctl get_param -n $obdname.${!target}.instance)
+        local ci=$(lctl get_param -n $cliname.${!target}-${cliname}-*.import | \
+                  awk '/instance/{ print $2 }' |head -1)
+
+        return $([ $si -eq $ci ])
+}
+
+test_100()
+{
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        # disable IR
+        set_ir_status disabled
+
+        local saved_FAILURE_MODE=$FAILURE_MODE
+        [ $(facet_host mgs) = $(facet_host ost1) ] && FAILURE_MODE="SOFT"
+        fail ost1
+
+        # valid check
+        nidtbl_versions_match &&
+                error "version must differ due to IR disabled"
+        target_instance_match ost1 || error "instance mismatch"
+
+        # restore env
+        set_ir_status full
+        FAILURE_MODE=$saved_FAILURE_MODE
+}
+run_test 100 "IR: Make sure normal recovery still works w/o IR"
+
+test_101()
+{
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        set_ir_status full
+
+        local OST1_IMP=$(get_osc_import_name client ost1)
+
+        # disable pinger recovery
+        lctl set_param -n osc.$OST1_IMP.pinger_recov=0
+
+        fail ost1
+
+        target_instance_match ost1 || error "instance mismatch"
+        nidtbl_versions_match || error "version must match"
+
+        lctl set_param -n osc.$OST1_IMP.pinger_recov=1
+}
+run_test 101 "IR: Make sure IR works w/o normal recovery"
+
+test_102()
+{
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        local clients=${CLIENTS:-$HOSTNAME}
+        local old_version
+        local new_version
+        local mgsdev=mgs
+
+        set_ir_status full
+
+        # let's have a new nidtbl version
+        fail ost1
+
+        # sleep for a while so that clients can see the failure of ost
+        # it must be MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC.
+        # int mgc_request.c:
+        # define MGC_TIMEOUT_MIN_SECONDS   5
+        # define MGC_TIMEOUT_RAND_CENTISEC 0x1ff /* ~500 *
+        local count=30  # 20 seconds at most
+        while [ $count -gt 0 ]; do
+                nidtbl_versions_match && break
+                sleep 1
+                count=$((count-1))
+        done
+
+        nidtbl_versions_match || error "nidtbl mismatch"
+
+        # get the version #
+        old_version=$(nidtbl_version_client client)
+
+        zconf_umount_clients $clients $MOUNT || error "Cannot umount client"
+
+        # restart mgs
+        combined_mgs_mds && mgsdev=mds1
+        remount_facet $mgsdev
+        fail ost1
+
+        zconf_mount_clients $clients $MOUNT || error "Cannot mount client"
+
+        # check new version
+        new_version=$(nidtbl_version_client client)
+        [ $new_version -lt $old_version ] &&
+                error "nidtbl version wrong after mgs restarts"
+        return 0
+}
+run_test 102 "IR: New client gets updated nidtbl after MGS restart"
+
+test_103()
+{
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        combined_mgs_mds && skip "mgs and mds on the same target" && return 0
+
+        # workaround solution to generate config log on the mds
+        remount_facet mds1
+
+        stop mgs
+        stop mds1
+
+        # We need this test because mds is like a client in IR context.
+        start mds1 $MDSDEV1 || error "MDS should start w/o mgs"
+
+        # start mgs and remount mds w/ ir
+        start mgs $MGSDEV
+        clients_up
+
+        # remount client so that fsdb will be created on the MGS
+        umount_client $MOUNT || error "umount failed"
+        mount_client $MOUNT || error "mount failed"
+
+        # sleep 30 seconds so the MDS has a chance to detect MGS restarting
+        local count=30
+        while [ $count -gt 0 ]; do
+                [ $(nidtbl_version_client mds1) -ne 0 ] && break
+                sleep 1
+                count=$((count-1))
+        done
+
+        # after a while, mds should be able to reconnect to mgs and fetch
+        # up-to-date nidtbl version
+        nidtbl_versions_match mds1 || error "mds nidtbl mismatch"
+
+        # reset everything
+        set_ir_status full
+}
+run_test 103 "IR: MDS can start w/o MGS and get updated nidtbl later"
+
+test_104()
+{
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        set_ir_status full
+
+        stop ost1
+        start ost1 $(ostdevname 1) "$OST_MOUNT_OPTS -onoir" ||
+                error "OST1 cannot start"
+        clients_up
+
+        local ir_state=$(check_target_ir_state ost1)
+        [ $ir_state = "OFF" ] || error "ir status on ost1 should be OFF"
+}
+run_test 104 "IR: ost can disable IR voluntarily"
+
+test_105()
+{
+        [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
+        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+                { skip "MGS without IR support"; return 0; }
+
+        set_ir_status full
+
+        # get one of the clients from client list
+        local rcli=$(echo $RCLIENTS |cut -d' ' -f 1)
+
+        local old_MOUNTOPT=$MOUNTOPT
+        MOUNTOPT=${MOUNTOPT},noir
+        zconf_umount $rcli $MOUNT || error "umount failed"
+        zconf_mount $rcli $MOUNT || error "mount failed"
+
+        # make sure lustre mount at $rcli disabling IR
+        local ir_state=$(check_cli_ir_state $rcli)
+        [ $ir_state = OFF ] || error "IR state must be OFF at $rcli"
+
+        # make sure MGS's state is Partial
+        [ $(get_ir_status) = "partial" ] || error "MGS IR state must be partial"
+
+        fail ost1
+        # make sure IR on ost1 is OFF
+        local ir_state=$(check_target_ir_state ost1)
+        [ $ir_state = "OFF" ] || error "IR status on ost1 should be OFF"
+
+        # restore it
+        MOUNTOPT=$old_MOUNTOPT
+        zconf_umount $rcli $MOUNT || error "umount failed"
+        zconf_mount $rcli $MOUNT || error "mount failed"
+
+        # make sure MGS's state is full
+        [ $(get_ir_status) = "full" ] || error "MGS IR status must be full"
+
+        fail ost1
+        # make sure IR on ost1 is ON
+        local ir_state=$(check_target_ir_state ost1)
+        [ $ir_state = "ON" ] || error "IR status on ost1 should be OFF"
+
+        return 0
+}
+run_test 105 "IR: NON IR clients support"
+
+complete $(basename $0) $SECONDS
 check_and_cleanup_lustre
-[ -f "$TESTSUITELOG" ] && cat $TESTSUITELOG || true
+exit_status